Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestInput/FrmRequestInputAuxiliary.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestInput/FrmRequestInputAuxiliary.cs	(revision 59)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestInput/FrmRequestInputAuxiliary.cs	(revision 60)
@@ -991,525 +2004,775 @@
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
         }
+        #endregion
 
-        /// <summary>
-        /// 合計行列表示設定
-        /// </summary>
-        /// <param name="colIndex"></param>
-        /// <param name="count"></param>
-        private void SetTotalInfoColumn(ColumnIndex colIndex, int count = 1)
+        #region 請求回の追加
+        private void AddRequestOrder()
         {
-            // カラムインデックス取得
-            int cIndex = GetColumnIndexNum(colIndex, count);
+            int nOldMaxOrderNo = m_nMaxOrderNo;
 
-            SetTotalInfoColumn(cIndex);
+            // 請求回数を加算
+            m_nMaxOrderNo++;
+
+            RequestHead ReqHeadFrom = m_lstRequestHead[nOldMaxOrderNo - 1];
+
+            RequestHead ReqHeadTo = new RequestHead();
+
+            ReqHeadTo.ReqConstructionCode = m_ConstructionCode;           // 請求工事番号
+
+            // 請求Noは登録時に採番
+
+            // 受付番号は最大受付番号に準拠                                      
+            ReqHeadTo.OrderNo = m_nMaxOrderNo;
+
+            // 請求年月は登録時に決定（初期値）      
+
+            // 発注者区分、発注者コード、発注者名、工事件名は引き継ぐ
+            ReqHeadTo.OrderersDivision = m_BaseConstructionBaseInfo.OrderersDivision;   // 発注者区分   
+            ReqHeadTo.OrderersCode = m_BaseConstructionBaseInfo.OrderersCode;           // 発注者コード
+            ReqHeadTo.OrderersName = ReqHeadFrom.OrderersName;                          // 発注者名
+            ReqHeadTo.ReqConstructionName = ReqHeadFrom.ReqConstructionName;            // 工事件名
+
+            // 請求金額関係は全て0（初期値）
+            // 備考は初期値
+            // 割当済フラグも初期値
+            // 請求書Noも初期値
+
+            // 請求ヘッダリストに追加
+            m_lstRequestHead.Add(ReqHeadTo);
+
+            Dictionary<int, RequestData> dicDataForm = m_lstRequestData[nOldMaxOrderNo - 1];
+            Dictionary<int, RequestData> dicDataTo = new Dictionary<int, RequestData>();
+            CopyRequestDataDic(dicDataForm, ref dicDataTo);
+
+            m_lstRequestData.Add(dicDataTo);
+
+            Dictionary<int, List<RequestDataDetail>> dicDetailFrom = m_lstRequestDataDetail[nOldMaxOrderNo - 1];
+            Dictionary<int, List<RequestDataDetail>> dicDetailTo = new Dictionary<int, List<RequestDataDetail>>();
+            CopyRequestDetailDic(dicDetailFrom, ref dicDetailTo);
+
+            m_lstRequestDataDetail.Add(dicDetailTo);
+
+            return;
         }
+        #endregion
 
-        /// <summary>
-        /// 合計行列表示設定
-        /// </summary>
-        /// <param name="cIndex"></param>
-        private void SetTotalInfoColumn(int cIndex)
-        { 
-            try
+        #region 請求データの複写
+        private void CopyRequestDataDic(Dictionary<int, RequestData> dicDataForm, ref Dictionary<int, RequestData> dicDataTo)
+        {
+            List<int> lstKey = new List<int>(dicDataForm.Keys);
+
+            foreach (int nMainConstructionCode in lstKey)
             {
-                // DataGridViewRowのオブジェクトを取得
-                var gridRowBillPrice = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.BillPrice);
-                var gridRowNonTaxed = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.NonTaxedPrice);
-                var gridRowTaxPrice = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.TaxPrice);
+                RequestData ReqDataFrom = null;
 
-                // 税抜き価格と消費税額を計算
-                double nonTaxedPrice = Convert.ToDouble(GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.BillPrice).Cells[cIndex].Value);
-                double taxPrice = Convert.ToDouble(GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.TaxPrice).Cells[cIndex].Value);
-                for (int childRow = 0; childRow < m_ChildConstructionRowCount; childRow++)
+                if (dicDataForm.TryGetValue(nMainConstructionCode, out ReqDataFrom) == true)
                 {
-                    nonTaxedPrice += Convert.ToDouble(GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, RowKind.BillPrice, childRow).Cells[cIndex].Value ?? 0.0);
-                    taxPrice += Convert.ToDouble(GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, RowKind.TaxPrice, childRow).Cells[cIndex].Value ?? 0.0);
+                    RequestData ReqDataTo = new RequestData();
+
+                    // 請求Noは登録時に採番
+
+                    // 本工事番号、工事件名、請負金額は引き継ぐ
+                    ReqDataTo.MainConstructionCode = ReqDataFrom.MainConstructionCode;
+                    ReqDataTo.ConstructionName = ReqDataFrom.ConstructionName;
+                    ReqDataTo.ContractAmount = ReqDataFrom.ContractAmount;
+
+                    dicDataTo.Add(nMainConstructionCode, ReqDataTo);
+
                 }
+            }
+            return;
+        }
+        #endregion
 
-                // 行に表示設定
-                SetDataGridCellDecimal(gridRowNonTaxed.Cells[cIndex], nonTaxedPrice);
-                SetDataGridCellDecimal(gridRowTaxPrice.Cells[cIndex], taxPrice);
-                SetDataGridCellDecimal(gridRowBillPrice.Cells[cIndex], nonTaxedPrice + taxPrice);
+        #region 請求データ明細の複写
+        private void CopyRequestDetailDic(Dictionary<int, List<RequestDataDetail>> dicDetailFrom, ref Dictionary<int, List<RequestDataDetail>> dicDetailTo)
+        {
 
-                // 処理中の列が工事金額列以外であれば以下の処理
-                if (GetColumnIndexNum(ColumnIndex.ConstructionPrice) != cIndex)
+            List<int> lstKey = new List<int>(dicDetailFrom.Keys);
+
+            foreach (int nMainConstructionCode in lstKey)
+            {
+                List<RequestDataDetail> lstDetailFrom = null;
+
+                if (dicDetailFrom.TryGetValue(nMainConstructionCode, out lstDetailFrom) == true)
                 {
-                    // 未入金分
-                    var gridRowAmount = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.AmountPrice);
+                    List<RequestDataDetail> lstDetailTo = new List<RequestDataDetail>();
 
-                    SetDataGridCellDecimal(gridRowAmount.Cells[cIndex], Convert.ToDouble(GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.AmountPrice).Cells[cIndex].Value ?? 0.0));
-                    gridRowAmount.Cells[cIndex].Value = Convert.ToDouble(GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.AmountPrice).Cells[cIndex].Value ?? 0.0);
+                    foreach (RequestDataDetail ReqDetailFrom in lstDetailFrom)
+                    {
+                        RequestDataDetail ReqDetailTo = new RequestDataDetail();
 
-                    // ヘッダセクションの請求書金額
-                    var gridRowBillTotalPrice = GetDataGridViewRowObject(RowSectionIndex.Header, RowKind.RequestSheetPrice);
-                    SetDataGridCellDecimal(gridRowBillTotalPrice.Cells[cIndex], nonTaxedPrice + taxPrice);
+                        // 請求Noは登録時に採番
 
+                        // 本工事番号、工事番号、工事区分は引き継ぐ
+                        ReqDetailTo.MainConstructionCode = ReqDetailFrom.MainConstructionCode;
+                        ReqDetailTo.ConstructionCode = ReqDetailFrom.ConstructionCode;
+                        ReqDetailTo.ConstructionKind = ReqDetailFrom.ConstructionKind;
+
+                        lstDetailTo.Add(ReqDetailTo);
+                    }
+
+                    dicDetailTo.Add(nMainConstructionCode, lstDetailTo);
                 }
-
             }
-            catch (Exception ex)
-            {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
-            }
         }
-        
-        /// <summary>
-        /// 承認状態を確認する
-        /// </summary>
-        /// <param name="lstProcApproval"></param>
-        /// <param name="dicApprovalMaster"></param>
-        /// <returns></returns>
-        private RequestApprovalStatus CheckApprovalStatus(List<ProcessApproval> lstProcApproval, Dictionary<int,ApprovalMaster> dicApprovalMaster)
+        #endregion
+
+        #endregion
+
+        #region データ登録関連
+
+        #region データ登録
+        public bool AcceptData()
         {
-            // 「入力中」で初期化する
-            RequestApprovalStatus stat = RequestApprovalStatus.NowInput;
+            SetDispData();
 
-            try
+            SaveDispData();
+
+            m_bDirty = false;
+
+            return true;
+        }
+        #endregion
+
+        #region 表示データをオブジェクトに反映
+        private void SetDispData()
+        {
+            // 請求ヘッダ反映
+            SetRequestHead();
+
+            // 請求データ、請求データ明細の反映
+            SetRequestData();
+
+            return;
+        }
+        #endregion
+
+        #region 請求ヘッダをオブジェクトに反映
+        private void SetRequestHead()
+        {
+            int tcol = m_nMaxOrderNo + 7;
+
+            // 請求ヘッダ取得
+            RequestHead ReqHead = m_lstRequestHead[m_nMaxOrderNo - 1];
+
+            ReqHead.ReqConstructionCode = m_ConstructionCode;                               // 請求工事番号
+            ReqHead.OrderNo = m_nMaxOrderNo;                                                // 受付番号
+            ReqHead.OrderersName = txtOrderer.Text.Trim();                                  // 請求先名
+            ReqHead.RequestMonth = int.Parse(cbReqMonth.SelectedValue.ToString());          // 請求月
+            ReqHead.ReqConstructionName = dgv1[4, 0].Value.ToString();                      // 請求件名
+
+            ReqHead.RequestTotalAmount = CommonMotions.cnvInt(dgv1[tcol, 2].Value);         // 請求金額合計
+            ReqHead.RequestAmount = CommonMotions.cnvInt(dgv1[tcol, 3].Value);              // 請求金額
+            ReqHead.TaxAmount = CommonMotions.cnvInt(dgv1[tcol, 4].Value);                  // 消費税
+            ReqHead.UnpaidAmount = CommonMotions.cnvInt(dgv1[tcol, 5].Value);               // 未入金
+
+            return;
+        }
+        #endregion
+
+        #region 請求データをオブジェクトに反映
+        private void SetRequestData()
+        {
+
+            Dictionary<int, RequestData> dicData = m_lstRequestData[m_nMaxOrderNo - 1];
+            Dictionary<int, List<RequestDataDetail>> dicDetail = m_lstRequestDataDetail[m_nMaxOrderNo - 1];
+
+            int tcol = m_nMaxOrderNo + 7;
+            int trow = 6;
+            int nIndex = 0;
+            int nMainConstructionCode;
+
+            RequestData ReqData = null ;
+            List<RequestDataDetail> lstDetail = null;
+          
+            int[] nAmounts = new int[] { 0,0,0,0,0,0,0 } ;
+
+            int nRequestTotal = 0;
+            int nTaxTotal = 0;
+            int nContractAmount = 0;
+            int nPaidAmount =0;
+
+            while (true)
             {
-                // 承認データをすべて参照する
-                foreach (var procApproval in lstProcApproval)
+                if(dgv1[2,trow].Value == null)
                 {
+                    break;
+                }
 
-                    if ((procApproval.ApprovalStatus == (int)CommonDefine.ApprovalStatus.Approval)
-                         && dicApprovalMaster.ContainsKey(procApproval.PersonCode)
-                         && dicApprovalMaster[procApproval.PersonCode].ApprovalAuthority == 1)
+                int nKind = int.Parse(dgv1[1,trow].Value.ToString());
+
+                // 区分がボディ（本工事）の場合
+                if (nKind == (int)dgvKind.BodyMainConstruction)
+                {
+                    // 前本工事がある場合
+                    if (ReqData != null)
                     {
-                        // 承認ステータスが「承認」で承認者が最終決裁者の場合、「承認済み」とし、ループを離脱する
-                        stat = RequestApprovalStatus.Approval;
-                        break;
+                        // 請求データの請求金額０～６と消費税は最後に設定
+                        ReqData.RequestAmount0 = nAmounts[0];                                       // 請求金額０（本工事）
+                        ReqData.RequestAmount1 = nAmounts[1];                                       // 請求金額１
+                        ReqData.RequestAmount2 = nAmounts[2];                                       // 請求金額２
+                        ReqData.RequestAmount3 = nAmounts[3];                                       // 請求金額３
+                        ReqData.RequestAmount4 = nAmounts[4];                                       // 請求金額４
+                        ReqData.RequestAmount5 = nAmounts[5];                                       // 請求金額５
+                        ReqData.RequestAmount6 = nAmounts[6];                                       // 請求金額６
+                        ReqData.TaxAmount = nTaxTotal;                                              // 消費税
+
+                        ReqData.UnclaimedAmount = nContractAmount - (nPaidAmount + nRequestTotal);    // 請求金額残
+
+                        nAmounts = new int[] { 0, 0, 0, 0, 0, 0, 0 };
+                        nRequestTotal = 0;
+                        nTaxTotal = 0;
                     }
-                    else if (procApproval.ApprovalStatus == (int)CommonDefine.ApprovalStatus.NotApproval)
+
+                    nMainConstructionCode = int.Parse(dgv1[2,trow].Value.ToString());
+
+                    dicData.TryGetValue(nMainConstructionCode, out ReqData);
+                    dicDetail.TryGetValue(nMainConstructionCode, out lstDetail);
+
+                    ReqData.ConstructionName = dgv1[4, trow].Value.ToString().Trim();           // 工事件名
+
+                    nContractAmount = GetContractAmount(nMainConstructionCode);
+                    nPaidAmount = GetPaidAmount(m_nMaxOrderNo, nMainConstructionCode);
+
+                    ReqData.ContractAmount = nContractAmount;                                   // 請負金額
+                    ReqData.PaidAmount = nPaidAmount;                                           // 請求済金額
+
+                    ReqData.Note = dgv1[dgv1.ColumnCount - 1, trow].Value.ToString();           // 備考
+
+                    // 先頭の本工事の場合
+                    if (trow == 6)
                     {
-                        // 不承認
-                        stat = RequestApprovalStatus.NotApproval;
+                        // 最初の本工事に未入金分は載せる
+                        ReqData.UnpaidAmount = CommonMotions.cnvInt(dgv1[tcol, 5].Value);       // 未入金
                     }
-                    else if ((procApproval.ApprovalStatus == (int)CommonDefine.ApprovalStatus.Pending)
-                        && (stat > RequestApprovalStatus.Pending))
+
+                    nIndex = 0;
+                }
+
+                RequestDataDetail ReqDetail = lstDetail[nIndex];
+
+                int nAmount = CommonMotions.cnvInt(dgv1[tcol, trow].Value);
+                int nTax = CommonMotions.cnvInt(dgv1[tcol, trow + 1].Value);
+
+                // 増減工事が6個未満(
+                if (lstDetail.Count < 8)
+                {
+                    nAmounts[nIndex] = nAmount; 
+                }
+                else
+                {
+                    if (nIndex > 0)
                     {
-                        // 保留
-                        stat = RequestApprovalStatus.Pending;
+                        nAmounts[1] += nAmount;
                     }
-                    else if ((procApproval.ApprovalStatus == (int)CommonDefine.ApprovalStatus.Approval)
-                        && (stat > RequestApprovalStatus.NowApproval))
+                    else
                     {
-                        // 承認中
-                        stat = RequestApprovalStatus.NowApproval;
+                        nAmounts[0] = nAmount;
                     }
-                    else if ((procApproval.ApprovalStatus == (int)CommonDefine.ApprovalStatus.Petition)
-                        && (stat > RequestApprovalStatus.Petition))
-                    {
-                        // 申請中
-                        stat = RequestApprovalStatus.Petition;
-                    }
                 }
+
+                //////////////////////
+                // 請求データ明細
+                //////////////////////
+
+                ReqDetail.RequestAmount = nAmount;          // 請求金額
+                ReqDetail.TaxAmount = nTax;                 // 消費税
+
+                // 請求データ、消費税は請求データ用に合算していく
+                nRequestTotal += nAmount;
+                nTaxTotal += nTax;                          
+
+                // 行は2行ずつ加算
+                trow += 2;
+
+                // 要素は1つずつ加算
+                nIndex++;
+
             }
-            catch (Exception ex)
+
+            // 前本工事がある場合
+            if (ReqData != null)
             {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                // 請求データの請求金額０～６と消費税は最後に設定
+                ReqData.RequestAmount0 = nAmounts[0];                                   // 請求金額０（本工事）
+                ReqData.RequestAmount1 = nAmounts[1];                                   // 請求金額１
+                ReqData.RequestAmount2 = nAmounts[2];                                   // 請求金額２
+                ReqData.RequestAmount3 = nAmounts[3];                                   // 請求金額３
+                ReqData.RequestAmount4 = nAmounts[4];                                   // 請求金額４
+                ReqData.RequestAmount5 = nAmounts[5];                                   // 請求金額５
+                ReqData.RequestAmount6 = nAmounts[6];                                   // 請求金額６
+                ReqData.TaxAmount = nTaxTotal;                                          // 消費税
+                ReqData.UnclaimedAmount = nContractAmount - (nPaidAmount + nRequestTotal);    // 請求金額残
             }
-            return stat;
+
+            return;
         }
+        #endregion
 
-        /// <summary>
-        /// 請求明細列を表示設定
-        /// </summary>
-        /// <param name="reqIndex"></param>
-        private void SetRequestInfoColumn(int reqIndex)
+        #region 請負金額の取得
+        private int GetContractAmount(int nMainConstructionCode)
         {
-            try
+            int nContractAmount = 0;
+
+            Dictionary<int, List<RequestDataDetail>> dicDataDetail = m_lstRequestDataDetail[m_nMaxOrderNo-1];
+
+            List<RequestDataDetail> lstReqDetail = null;
+            if (dicDataDetail.TryGetValue(nMainConstructionCode, out lstReqDetail) == false)
             {
-                int cIndex;
-                int orderNo = m_LstRequestTotalData[reqIndex].OrderNo;
+                return nContractAmount;
+            }
 
-                // 列が足りない場合は追加する
-                if (reqIndex + 1 > m_RequestColumnCount)
-                {
-                    cIndex = GetColumnIndexNum(ColumnIndex.Amount);
-                    DataGridViewColumn colObj = new DataGridViewTextBoxColumn();
-                    colObj.ReadOnly = true;
-                    colObj.Width = 120;
-                    dgv1.Columns.Insert(cIndex, colObj);
-                    m_RequestColumnCount++;
-                    dgv1.Columns[cIndex].HeaderText = string.Format("{0}回目", reqIndex + 1);
-                }
-                else
-                {
-                    cIndex = GetColumnIndexNum(ColumnIndex.RequestInfo, reqIndex + 1);
-                }
-                dgv1.Columns[cIndex].HeaderCell.Style.ForeColor = Color.Black;
+            foreach (RequestDataDetail ReqDetail in lstReqDetail)
+            {
+                ConstructionBaseInfo Info = null;
+                m_dicConstructionBaseInfo.TryGetValue(ReqDetail.ConstructionCode, out Info);
 
-                var requestTotalData = m_LstRequestTotalData[reqIndex];
+                nContractAmount += CommonMotions.cnvInt(Info.OrdersDecisionPrice);
+            }
 
-                // 請求書作成日
-                if (requestTotalData.BillCreationDate != DateTime.MinValue)
+            return nContractAmount;
+        }
+        #endregion
+
+        #region 請求済み金額の取得
+        private int GetPaidAmount(int nMaxOrderNo, int MainConstructionCode)
+        {
+            int nPaidAmount = 0;
+            RequestData ReqData = null;
+
+            if( m_nMaxOrderNo > 1 ){
+                // 直前の請求データをみればよい
+                Dictionary<int, RequestData> dicData = m_lstRequestData[m_nMaxOrderNo-2];
+
+                if (dicData.TryGetValue(MainConstructionCode, out ReqData) == true)
                 {
-                    var gridRowRequestCreateDate = GetDataGridViewRowObject(RowSectionIndex.Header, RowKind.RequestSheetCreateDate);
-                    gridRowRequestCreateDate.Cells[cIndex].Value = requestTotalData.BillCreationDate.ToShortDateString();
-                    gridRowRequestCreateDate.Cells[cIndex].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;
+                    nPaidAmount += ReqData.PaidAmount;
+                    nPaidAmount += ReqData.RequestAmount0;
+                    nPaidAmount += ReqData.RequestAmount1;
+                    nPaidAmount += ReqData.RequestAmount2;
+                    nPaidAmount += ReqData.RequestAmount3;
+                    nPaidAmount += ReqData.RequestAmount4;
+                    nPaidAmount += ReqData.RequestAmount5;
+                    nPaidAmount += ReqData.RequestAmount6;
                 }
+            }
 
-                // 承認状態
-                var gridRowApprovalStatus = GetDataGridViewRowObject(RowSectionIndex.Header, RowKind.ApprobalStatus);
-                RequestApprovalStatus stat = RequestApprovalStatus.NowInput;
-                if (m_DicProcessApproval.ContainsKey(orderNo))
+            return nPaidAmount;
+        }
+        #endregion
+
+        #region データの保存
+        private bool SaveDispData()
+        {
+            int nRequestNo = 0;
+            bool bAdd = false;
+
+            IORequestHead ioReqHead = new IORequestHead();
+            IORequestData ioReqData = new IORequestData();
+            IORequestDataDetail ioReqDetail = new IORequestDataDetail();
+            IOConstructionLedgerExcute ioLdgExcute = new IOConstructionLedgerExcute();
+
+            ioReqHead.beginTran();
+            ioReqData.beginTran();
+            ioReqDetail.beginTran();
+            ioLdgExcute.beginTran();
+
+            RequestHead ReqHead = m_lstRequestHead[m_nMaxOrderNo - 1];
+
+            try{
+                string sql;
+
+                nRequestNo = ReqHead.RequestNo;
+
+                if (nRequestNo != 0)
                 {
-                    stat = CheckApprovalStatus(m_DicProcessApproval[orderNo], m_DicApprovalMaster);
-                }
-                gridRowApprovalStatus.Cells[cIndex].Value = s_DictApprovalStatusString[stat];
-                gridRowApprovalStatus.Cells[cIndex].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;
+                    // 請求Noの要素である請求月を求める
+                    int nMonth = CommonMotions.cnvTruncate((double)nRequestNo / 1000);
 
-                // 本工事行
-                if (m_DicRequestDataDetail.ContainsKey(m_ConstructionCode))        // 本工事分の明細があることを確認
-                {
-                    RequestDataDetail detail;
-                    if (m_DicRequestDataDetail[m_ConstructionCode].ContainsKey(orderNo))
+                    // 請求月が一致してない場合は、データを再登録
+                    if (nMonth != ReqHead.RequestMonth)
                     {
-                        detail = m_DicRequestDataDetail[m_ConstructionCode][orderNo];
-                    }
-                    else
-                    {
-                        detail = m_DicRequestDataDetail[m_ConstructionCode][orderNo] = new RequestDataDetail();
-                        detail.RequestNo = m_RequestData.RequestNo;
-                        detail.ConstructionCode = m_ConstructionCode;
-                        detail.OrderNo = orderNo;
-                        detail.ConstructionKind = 0;
-                    }
+                        // 当該受付回目の請求データ明細を削除
+                        sql = ioReqDetail.CreatePrimarykeyString(nRequestNo);
+                        if (ioReqDetail.DeleteAction(sql) == false)
+                        {
+                            ioReqHead.rollback();
+                            ioReqData.rollback();
+                            ioReqDetail.rollback();
+                            ioLdgExcute.rollback();
+                            return false;
+                        }
 
-                    // 請求金額
-                    var gridRowOrgBillPrice = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.BillPrice);
-                    SetDataGridCellDecimal(gridRowOrgBillPrice.Cells[cIndex], (double)detail.BillPrice);
-                    gridRowOrgBillPrice.Cells[cIndex].ReadOnly = (stat == RequestApprovalStatus.Approval) ? true : false;
+                        // 当該受付回目の請求データを削除
+                        sql = ioReqData.CreatePrimarykeyString(nRequestNo);
+                        if (ioReqData.DeleteAction(sql) == false)
+                        {
+                            ioReqHead.rollback();
+                            ioReqData.rollback();
+                            ioReqDetail.rollback();
+                            ioLdgExcute.rollback();
+                            return false;
+                        }
 
-                    // 消費税
-                    var gridRowOrgTaxPrice = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.TaxPrice);
-                    SetDataGridCellDecimal(gridRowOrgTaxPrice.Cells[cIndex], (double)detail.TaxPrice);
-                    gridRowOrgTaxPrice.Cells[cIndex].ReadOnly = (stat == RequestApprovalStatus.Approval) ? true : false;
+                        // 請求ヘッダを削除
+                        sql = ioReqHead.CreatePrimarykeyString(nRequestNo);
+                        if (ioReqHead.DeleteAction(sql) == false)
+                        {
+                            ioReqHead.rollback();
+                            ioReqData.rollback();
+                            ioReqDetail.rollback();
+                            ioLdgExcute.rollback();
+                            return false;
+                        }
 
-                    // 未入金分
-                    var gridRowOrgAmount = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.AmountPrice);
-                    SetDataGridCellDecimal(gridRowOrgAmount.Cells[cIndex], (double)detail.AmountBlance);
-                    gridRowOrgAmount.Cells[cIndex].ReadOnly = (stat == RequestApprovalStatus.Approval) ? true : false;
+                        nRequestNo = 0;
+                    }
+                }
 
+                // ＤＢ未登録の場合
+                if (nRequestNo == 0)
+                {
+                    // 請求Noを採番
+                    nRequestNo = ioReqHead.NumberingRequestNo(ReqHead.RequestMonth);
+
+                    bAdd = true;
                 }
 
-                // 増減工事行
-                foreach (int constCode in m_LstConstructionLink)
+                // 更新の場合
+                if (bAdd == false)
                 {
-                    Dictionary<int, RequestDataDetail> dicRequestDataDetail;
-                    if (m_DicRequestDataDetail.ContainsKey(constCode))
-                    {
-                        dicRequestDataDetail = m_DicRequestDataDetail[constCode];
+                    // 請求ヘッダの更新
+                    sql = ioReqHead.CreatePrimarykeyString(nRequestNo);
+                    if( ioReqHead.UpdateAction(sql, ReqHead) == false){
+                        ioReqHead.rollback();
+                        ioReqData.rollback();
+                        ioReqDetail.rollback();
+                        ioLdgExcute.rollback();
+                        return false;
                     }
-                    else
+
+                    // 当該受付回目の請求データ明細を削除
+                    sql = ioReqDetail.CreatePrimarykeyString(nRequestNo);
+                    if (ioReqDetail.DeleteAction(sql) == false)
                     {
-                        dicRequestDataDetail = m_DicRequestDataDetail[constCode] = new Dictionary<int, RequestDataDetail>();
+                        ioReqHead.rollback();
+                        ioReqData.rollback();
+                        ioReqDetail.rollback();
+                        ioLdgExcute.rollback();
+                        return false;
                     }
 
-                    RequestDataDetail detail;
-                    if (dicRequestDataDetail.ContainsKey(orderNo))
+                    // 当該受付回目の請求データを削除
+                    sql = ioReqData.CreatePrimarykeyString(nRequestNo);
+                    if (ioReqData.DeleteAction(sql) == false)
                     {
-                        detail = dicRequestDataDetail[orderNo];
+                        ioReqHead.rollback();
+                        ioReqData.rollback();
+                        ioReqDetail.rollback();
+                        ioLdgExcute.rollback();
+                        return false;
                     }
-                    else
-                    {
-                        detail = dicRequestDataDetail[orderNo] = new RequestDataDetail();
-                        detail.RequestNo = m_RequestData.RequestNo;
-                        detail.ConstructionCode = constCode;
-                        detail.OrderNo = orderNo;
-                        detail.ConstructionKind = 1;
+
+                }
+                else
+                {
+                    // 請求ヘッダの追加
+                    ReqHead.RequestNo = nRequestNo;
+                    if(ioReqHead.InsertAction(ReqHead) == false){
+                        ioReqHead.rollback();
+                        ioReqData.rollback();
+                        ioReqDetail.rollback();
+                        ioLdgExcute.rollback();
+                        return false;
                     }
+                }
 
-                    // 請求金額
-                    var gridRowChldBillPrice = GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, RowKind.BillPrice, m_LstConstructionLink.IndexOf(constCode));
-                    SetDataGridCellDecimal(gridRowChldBillPrice.Cells[cIndex], (double)detail.BillPrice);
-                    gridRowChldBillPrice.Cells[cIndex].ReadOnly = (stat == RequestApprovalStatus.Approval) ? true : false;
+                // 請求データ以下は常に追加
 
-                    // 消費税
-                    var gridRowChldTaxPrice = GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, RowKind.TaxPrice, m_LstConstructionLink.IndexOf(constCode));
-                    SetDataGridCellDecimal(gridRowChldTaxPrice.Cells[cIndex], (double)detail.TaxPrice);
-                    gridRowChldTaxPrice.Cells[cIndex].ReadOnly = (stat == RequestApprovalStatus.Approval) ? true : false;
+                // 請求データをリストに設定
+                List<RequestData> lstData = new List<RequestData>();
+                SetRequestDataList(nRequestNo, ref lstData);
 
+                // 請求データの追加
+                if (ioReqData.InsertAction(lstData) == false)
+                {
+                    ioReqHead.rollback();
+                    ioReqData.rollback();
+                    ioReqDetail.rollback();
+                    ioLdgExcute.rollback();
+                    return false;
                 }
 
-                // OrderNoで入金明細があるかを確認
-                var depositDetail = m_DicDepositDataDetail.ContainsKey(orderNo) ? m_DicDepositDataDetail[orderNo] : new DepositDataDetail();
+                // 請求データ明細リストに設定
+                List<RequestDataDetail> lstDetail = new List<RequestDataDetail>();
+                SetRequestDataDetailList(nRequestNo, ref lstDetail);
 
-                if (m_DicDepositDataDetail.ContainsKey(orderNo))
+                // 請求データ明細の追加
+                if (ioReqDetail.InsertAction(lstDetail) == false)
                 {
-                    // あったら入金データを取得
-                    var depositData = new DepositData();
-                    if (GetDepositData(depositDetail.OrderersDivision,
-                                        depositDetail.OrderersCode,
-                                        depositDetail.TargetDate,
-                                        depositDetail.SeqNo,
-                                        ref depositData))
-                    {
-                        // 取得できたら表示設定
+                    ioReqHead.rollback();
+                    ioReqData.rollback();
+                    ioReqDetail.rollback();
+                    ioLdgExcute.rollback();
+                    return false;
+                }
 
-                        // 入金日
-                        var gridRowDepositDate = GetDataGridViewRowObject(RowSectionIndex.DepositInfo, RowKind.DepositDate);
-                        gridRowDepositDate.Cells[cIndex].Value = depositData.DepositDate.ToShortDateString();
+                // 詳細台帳へ請求金額の反映
+                if (UpdateRequestAmount(ref ioLdgExcute, ReqHead) == false)
+                {
+                    ioReqHead.rollback();
+                    ioReqData.rollback();
+                    ioReqDetail.rollback();
+                    ioLdgExcute.rollback();
 
-                    }
-
-                    // 入金金額
-                    var gridRowDepositPrice = GetDataGridViewRowObject(RowSectionIndex.DepositInfo, RowKind.DepositPrice);
-                    SetDataGridCellDecimal(gridRowDepositPrice.Cells[cIndex], (double)depositDetail.DepositAmount);
-
-                    // 差額
-                    var gridRowDepositDiff = GetDataGridViewRowObject(RowSectionIndex.DepositInfo, RowKind.DifferencePrice);
-                    SetDataGridCellDecimal(gridRowDepositDiff.Cells[cIndex], (double)depositDetail.CarryAmount);
-
-                    // 入金確認
-                    var gridRowDepositCheck = GetDataGridViewRowObject(RowSectionIndex.DepositInfo, RowKind.DepositCheck);
-                    gridRowDepositCheck.Cells[cIndex].Value = depositDetail.ApprovalEndFlg ? "確認済" : "";
-                    gridRowDepositCheck.Cells[cIndex].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;
+                    return false;
                 }
 
+                // コミット
+                ioReqHead.commit();
+                ioReqData.commit();
+                ioReqDetail.commit();
+                ioLdgExcute.commit();
             }
             catch (Exception ex)
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
+            finally
+            {
+                ioReqHead.close();
+                ioReqHead = null;
+                ioReqData.close();
+                ioReqData = null;
+                ioReqDetail.close();
+                ioReqDetail = null;
+                ioLdgExcute.close();
+                ioLdgExcute = null;
+            }
 
+            return true;
         }
+        #endregion
 
-        /// <summary>
-        /// DataGridViewCellに数値を表示設定する
-        /// </summary>
-        /// <param name="cell"></param>
-        /// <param name="value"></param>
-        private void SetDataGridCellDecimal(DataGridViewCell cell, double value)
+        #region 請求データリストの設定
+        private void SetRequestDataList(int nRequestNo, ref List<RequestData> lst)
         {
-            try
+
+            Dictionary<int, RequestData> dic = m_lstRequestData[m_nMaxOrderNo - 1];
+
+            List<int> lstKey = new List<int>(dic.Keys);
+
+            foreach (int nMainConstructionCode in lstKey)
             {
-                if (cell != null)
+                RequestData ReqData = null;
+
+                if (dic.TryGetValue(nMainConstructionCode, out ReqData) == true)
                 {
-                    cell.Value = value;
-                    cell.Style.Format = "#,0";
-                    cell.Style.ForeColor = (value < 0) ? Color.Red : Color.Black;
-                    cell.Style.Alignment = DataGridViewContentAlignment.MiddleRight;
+                    ReqData.RequestNo = nRequestNo;
+                    lst.Add(ReqData);
                 }
             }
-            catch (Exception ex)
-            {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
-            }
 
+            return;
         }
+        #endregion
 
-        /// <summary>
-        /// 請求回数追加
-        /// </summary>
-        private void AddRequest()
+        #region 請求データ明細リストの設定
+        private void SetRequestDataDetailList(int nRequestNo, ref List<RequestDataDetail> lst)
         {
-            try
-            {
-                // 請求合計データを追加
-                var totalData = new RequestTotalData();
-                totalData.RequestNo = m_RequestData.RequestNo;
-                totalData.OrderNo = m_LstRequestTotalData.Count + 1;
-                totalData.OrderersDivision = m_RequestData.OrderersDivision;
-                totalData.OrderersCode = m_RequestData.OrderersCode;
-                totalData.BillCreationDate = DateTime.MinValue;
 
-                m_LstRequestTotalData.Add(totalData);
+            Dictionary<int, List<RequestDataDetail>> dic = m_lstRequestDataDetail[m_nMaxOrderNo - 1];
 
-                // 請求明細データの追加の対象となる工事番号を収集
-                List<int> lstConstCodes = new List<int>();
-                lstConstCodes.Add(m_ConstructionCode);
-                lstConstCodes.AddRange(m_LstConstructionLink);
+            List<int> lstKey = new List<int>(dic.Keys);
 
-                // 請求明細データを追加
-                foreach (int code in lstConstCodes)
+            foreach (int nMainConstructionCode in lstKey)
+            {
+                List<RequestDataDetail> lstDetail = null;
+
+                if (dic.TryGetValue(nMainConstructionCode, out lstDetail) == true)
                 {
-                    if (!m_DicRequestDataDetail.ContainsKey(code))
+                    foreach (RequestDataDetail ReqDetail in lstDetail)
                     {
-                        m_DicRequestDataDetail[code] = new Dictionary<int, RequestDataDetail>();
+                        ReqDetail.RequestNo = nRequestNo;
+                        lst.Add(ReqDetail);
                     }
-
-                    var detail = new RequestDataDetail();
-                    detail.RequestNo = m_RequestData.RequestNo;
-                    detail.OrderNo = totalData.OrderNo;
-                    detail.ConstructionCode = code;
-                    detail.ConstructionKind = (code == m_ConstructionCode) ? 0 : 1;
-
-                    m_DicRequestDataDetail[code][detail.OrderNo] = detail;
                 }
+            }
 
-                // 追加した請求明細列表示
-                SetRequestInfoColumn(totalData.OrderNo - 1);
-
-                // 自動計算セル表示
-                SetAutoCalcRow();
-
-                // 合計セクション表示
-                SetTotalInfoColumn(ColumnIndex.RequestInfo, m_LstRequestTotalData.Count());
-
-                // 合計セクション合計列および残り列表示
-                SetTotalSectionInfo();
-
-            }
-            catch (Exception ex)
-            {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
-            }
+            return;
         }
+        #endregion
 
-        /// <summary>
-        /// 登録処理
-        /// </summary>
-        private bool AcceptData()
+        #region 詳細台帳の請求金額の更新
+        private bool UpdateRequestAmount(ref IOConstructionLedgerExcute ioLdgExcute, RequestHead ReqHead)
         {
-            bool ret;
+            string sql = "" ;
 
-            var reqDB = new IORequestData();
-            var reqTotalDB = new IORequestTotalData();
-            var reqDetailDB = new IORequestDataDetail();
+            IOConstructionLedgerDetail ioLdgDetail = new IOConstructionLedgerDetail();
+            List<ConstructionLedgerDetail> lstDetail = new List<ConstructionLedgerDetail>();
 
-            ret = true;
-
             try
             {
-                // ---------- 行インデックス ----------------
-                // 工事金額列インデックス
-                int constPriceColIndex = GetColumnIndexNum(ColumnIndex.ConstructionPrice);
+                // 請求金額の行番号を取得
+                sql = ioLdgDetail.CreatePrimarykeyString(m_nLeaderConstructionCode,(int)FrmConstructionLedger.DataGroup.BillingAmount);
+                if (ioLdgDetail.SelectAction(sql, ref lstDetail) == false)
+                {
+                    return false;
+                }
 
-                // 合計列インデックス
-                int totalColIndex = GetColumnIndexNum(ColumnIndex.Total);
+                // 詳細台帳がない場合は終了
+                if (lstDetail.Count == 0)
+                {
+                    return true;
+                }
 
-                // 残り列インデックス
-                int amountColIndex = GetColumnIndexNum(ColumnIndex.Amount);
+                int yyyy = 0;
+                int mm = 0;
+                DateTime dt = DateTime.MinValue;
 
+                ConstructionLedgerExcute LdgExcute = null;
 
-                // ---------- 行オブジェクト ----------------
-                var billPriceRow = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.BillPrice);
-                var nonTaxedRow = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.NonTaxedPrice);
-                var taxPriceRow = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.TaxPrice);
-                var amountRow = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.AmountPrice);
-                var orgAmountRow = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.AmountPrice);
+                List<ConstructionLedgerExcute> lstExcute = new List<ConstructionLedgerExcute>();
 
-                // 更新用データ収集処理
-                m_RequestData.AmountPaid = 0;
-                m_RequestData.PricePaid = 0;
-                m_RequestData.TaxPricePaid = 0;
-                m_RequestData.AmountBlance = 0;
-                int totalAmountPaid = 0;
-                int totalPricePaid = 0;
-                int totalTaxPaid = 0;
-
-                foreach (var totalData in m_LstRequestTotalData)
+                // 旧請求年月が指定されている場合は、一旦旧請求金額を差し引く
+                if( m_nOldRequestMonth != 0)
                 {
-                    int cIndex = GetColumnIndexNum(ColumnIndex.RequestInfo, m_LstRequestTotalData.IndexOf(totalData) + 1);
+                    yyyy = CommonMotions.cnvTruncate((double)m_nOldRequestMonth / 100);
+                    mm = m_nOldRequestMonth % 100;
 
-                    // 承認データチェック
-                    RequestApprovalStatus stat = RequestApprovalStatus.NowInput;
-                    if (m_DicProcessApproval.ContainsKey(totalData.OrderNo))
+                    dt = new DateTime( yyyy, mm, 1);
+
+                    sql = ioLdgExcute.CreatePrimarykeyString(m_nLeaderConstructionCode, lstDetail[0].GroupCount, lstDetail[0].LineCount);
+                    sql += string.Format(" AND TargetMonth = STR_TO_DATE('{0}', '%Y%m%d') ", dt.ToString("yyyyMMdd"));
+
+                    if (ioLdgExcute.SelectAction(sql, ref lstExcute) == false)
                     {
-                        stat = CheckApprovalStatus(m_DicProcessApproval[totalData.OrderNo], m_DicApprovalMaster);
+                        return false;
                     }
 
-                    if (stat < RequestApprovalStatus.NowInput)
+                    // 旧請求年月があってレコードなしはありえない
+                    if(lstExcute.Count == 0)
                     {
-                        // 請求済金額
-                        m_RequestData.AmountPaid += Convert.ToInt32(billPriceRow.Cells[cIndex].Value);
+                        return false;
+                    }
 
-                        // 請求済工事金額
-                        m_RequestData.PricePaid += Convert.ToInt32(nonTaxedRow.Cells[cIndex].Value);
+                    LdgExcute = lstExcute[0];
 
-                        // 請求済消費税金額
-                        m_RequestData.TaxPricePaid += Convert.ToInt32(taxPriceRow.Cells[cIndex].Value);
-
-                        // 未入金額
-                        m_RequestData.AmountBlance -= Convert.ToInt32(orgAmountRow.Cells[cIndex].Value);
+                    // 請求金額から旧請求金額を差し引いた金額で更新
+                    LdgExcute.PaymentAmount -= (double)m_nOldRequestAmount;
+                    sql = ioLdgExcute.CreatePrimarykeyString( LdgExcute.ConstructionCode, LdgExcute.GroupCount, LdgExcute.LineCount, LdgExcute.ColumnCount);
+                    if( ioLdgExcute.UpdateAction(sql, LdgExcute) == false)
+                    {
+                        return false;
                     }
 
-                    // 請求合計データ
-                    totalData.BillTotalPrice = Convert.ToInt32(billPriceRow.Cells[cIndex].Value);
-                    totalData.BillPrice = Convert.ToInt32(nonTaxedRow.Cells[cIndex].Value);
-                    totalData.TaxPrice = Convert.ToInt32(taxPriceRow.Cells[cIndex].Value);
-                    totalData.AmountBlance = Convert.ToInt32(amountRow.Cells[cIndex].Value);
-                    totalData.AmountPaid = (totalAmountPaid += Convert.ToInt32(billPriceRow.Cells[cIndex].Value));
-                    totalData.PricePaid = (totalPricePaid += Convert.ToInt32(nonTaxedRow.Cells[cIndex].Value));
-                    totalData.TaxPricePaid = (totalTaxPaid += Convert.ToInt32(taxPriceRow.Cells[cIndex].Value));
-                    totalData.PriceBalance = Convert.ToInt32(nonTaxedRow.Cells[constPriceColIndex].Value) - totalPricePaid;
-                    totalData.TaxBalance = Convert.ToInt32(taxPriceRow.Cells[constPriceColIndex].Value) - totalTaxPaid;
+                    // リストをクリア
+                    lstExcute.Clear();
+                }
 
-                    // 請求合計データテーブル更新および追加処理
-                    if (m_DicReqTotalRec.ContainsKey(totalData))
+                // 請求ヘッダより請求月を求める
+                yyyy = CommonMotions.cnvTruncate((double)ReqHead.RequestMonth / 100);
+                mm = ReqHead.RequestMonth % 100;
+                dt = new DateTime( yyyy, mm, 1);
+
+                // 当該月の請求金額のレコードがあるか取得してみる
+                sql = ioLdgExcute.CreatePrimarykeyString(m_nLeaderConstructionCode, lstDetail[0].GroupCount, lstDetail[0].LineCount);
+                sql += string.Format(" AND TargetMonth = STR_TO_DATE('{0}', '%Y%m%d') ", dt.ToString("yyyyMMdd"));
+                if (ioLdgExcute.SelectAction(sql, ref lstExcute) == false)
+                {
+                    return false;
+                }
+
+                // レコードが存在する場合
+                if (lstExcute.Count > 0)
+                {
+                    LdgExcute = lstExcute[0];
+                    
+                    // 請求金額を加算して更新
+                    LdgExcute.PaymentAmount += ReqHead.RequestAmount;
+                    sql = ioLdgExcute.CreatePrimarykeyString(LdgExcute.ConstructionCode, LdgExcute.GroupCount, LdgExcute.LineCount, LdgExcute.ColumnCount);
+                    if (ioLdgExcute.UpdateAction(sql, LdgExcute) == false)
                     {
-                        // データ読み込み時に存在したレコードなら更新
-                        reqTotalDB.UpdateAction("", totalData);
+                        return false;
                     }
-                    else
-                    {
-                        // データ読み込み時に存在しなかったレコードなら追加
-                        reqTotalDB.InsertAction(totalData);
-                        m_DicReqTotalRec[totalData] = true;
-                    }
+                }
+                else
+                {
+                    // 工事詳細台帳実行データを設定
+                    LdgExcute = new ConstructionLedgerExcute();
 
-                    foreach (var constCode in m_DicRequestDataDetail.Keys)
+                    LdgExcute.ConstructionCode = m_nLeaderConstructionCode;
+                    LdgExcute.GroupCount = lstDetail[0].GroupCount;
+                    LdgExcute.LineCount = lstDetail[0].LineCount;
+                    LdgExcute.ColumnCount = CalcTargetMonthToColumn(dt);
+                    LdgExcute.PaymentAmount = ReqHead.RequestAmount;
+                    LdgExcute.TargetMonth = dt;
+
+                    // レコードを挿入
+                    if (ioLdgExcute.InsertAction(LdgExcute) == false)
                     {
-                        if (m_DicReqDetailRec.ContainsKey(m_DicRequestDataDetail[constCode][totalData.OrderNo]))
-                        {
-                            // データ読み込み時に存在したレコードなら更新
-                            reqDetailDB.UpdateAction("", m_DicRequestDataDetail[constCode][totalData.OrderNo]);
-                        }
-                        else
-                        {
-                            // データ読み込み時に存在しなかったレコードなら追加
-                            reqDetailDB.InsertAction(m_DicRequestDataDetail[constCode][totalData.OrderNo]);
-                            m_DicReqDetailRec[m_DicRequestDataDetail[constCode][totalData.OrderNo]] = true;
-                        }
+                        return false;
                     }
-
                 }
 
-                // 請求残工事金額
-                m_RequestData.PriceBalance = Convert.ToInt32(nonTaxedRow.Cells[constPriceColIndex].Value) - m_RequestData.PricePaid;
 
-                // 請求残消費税金額
-                m_RequestData.TaxBalance = Convert.ToInt32(taxPriceRow.Cells[constPriceColIndex].Value) - m_RequestData.TaxPricePaid;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                ioLdgDetail.close();
+                ioLdgDetail = null;
+            }
+         
+            return true;
+        }
+        #endregion
 
-                // 未入金額
-                m_RequestData.AmountBlance += Convert.ToInt32(orgAmountRow.Cells[amountColIndex].Value) + Convert.ToInt32(orgAmountRow.Cells[totalColIndex].Value);
+        #region 請求月のカラム位置を算出
+        private int CalcTargetMonthToColumn(DateTime dtTarget)
+        {
+            int tcol = -1;
 
-                // 請求データが登録されていない場合はレコード作成
-                if (isEmptyConstructionBaseInfo)
+            IOConstructionLedgerExcute ioExcute;
+
+            ioExcute = new IOConstructionLedgerExcute();
+
+            try
+            {
+                string sql = ioExcute.CreatePrimarykeyString(m_nLeaderConstructionCode);
+                sql += " AND ColumnCount = 27";
+
+                List<ConstructionLedgerExcute> lstExcute = new List<ConstructionLedgerExcute>();
+
+                if (ioExcute.SelectAction(sql, ref lstExcute) == false)
                 {
-                    // 請求データ追加処理
-                    reqDB.InsertAction(m_RequestData);
-                } else
-                {
-                    // 請求データ更新処理
-                    reqDB.UpdateAction("", m_RequestData);
+                    return tcol;
                 }
 
-                reqDB.commit();
-                reqTotalDB.commit();
-                reqDetailDB.commit();
+                tcol = ClsChangeLedgerData.CalcTargetMonthToColumn(lstExcute[0].TargetMonth, dtTarget);
 
             }
             catch (Exception ex)
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
-
-                ret = false;
             }
             finally
             {
-                reqDB.close();
-                reqTotalDB.close();
-                reqDetailDB.close();
-                reqDB = null;
-                reqTotalDB = null;
-                reqDetailDB = null;
+                ioExcute.close();
+                ioExcute = null;
             }
 
-            return ret;
+            return tcol;
+        }
+        #endregion
 
-        }
+        #endregion
+
         #region データベースアクセスメソッド
 
         #region 工事基本情報
